<template>
  <div class="flex">
    <div class="flex-1 p-4">
      <h2>Patients</h2>
    <CreatePatientAccount />
    <div class="hello-searchbar">
      <div class="flex align-items-center">
        <i class="pi pi-search mr-2" />
        <InputText
          class="inputtext-searchbar flex-1"
          type="text"
          v-model="search"
          placeholder="Chercher un patient"
        />
        <span>({{ filteredPatients.length }})</span>
      </div>
    </div>
        <p v-if="filteredPatients.length == 0">Aucun patient n'est enregistré sur votre compte</p>
      <OrderList v-model="filteredPatients" listStyle="height:auto" dataKey="id">
        <template #item="patient">
          <div class="flex justify-content-between align-items-center">
            <div class="patient-item">
              <div class="image-container">
                <Avatar icon="pi pi-user" class="mr-2" size="xlarge" />
              </div>
              <div class="patient-list-detail">
                <h5 class="mb-2" style="margin-top: 0px">
                  {{ patient.item.nom }} {{ patient.item.prenom }}
                </h5>
                <i class="pi pi-briefcase patient-niveau-icon"></i>
                <span class="patient-niveau">{{ patient.item.classe }}</span>
                <div class="patient-description">{{ patient.item.description }}</div>
              </div>
            </div>

            <div>
              <Button
                label="Voir"
                @click="$router.push('/patient/' + patient.item.id)"
              />
            </div>
          </div>
        </template>
      </OrderList>
    </div>

    <div class="flex-1 p-4">
      <h2>Dictionnaire</h2>
        <AddWordToDict />

        <div class="hello-searchbar">
          <div class="flex align-items-center">
          <i class="pi pi-search mr-2" />
          <InputText
              class="inputtext-searchbar"
              type="text"
              v-model="searchWord"
              placeholder="Chercher un mot"
          />
          <span>({{ filteredWords.length }})</span>
          </div>
        </div>

        <OrderList class="mt-2" v-model="filteredWords" listStyle="height:auto" dataKey="id">
        <template #item="word">
          <div class="patient-item">
              <div class="patient-list-detail">
                <h5 class="mb-2" style="margin-top: 0px">
                  {{ word.item.orthographe }}
                </h5>
                <div>
                    <span class="patient-niveau">Phonem : <strong><span v-for="(item, index) in word.item.phonem" :key="index">{{ translate[item] }}</span></strong></span>
                </div>
                <span class="patient-niveau">Syllabe(s) : <span class="font-bold">{{ word.item.nb_syll }}</span></span>
                <span class="patient-niveau"> / Polysyllabique : <span class="font-bold" v-if="word.item.poly_syll">vrai</span><span class="font-bold" v-else>faux</span></span>
              </div>
              <Button @click="modifyWd(word.item.id)" class="mr-4" label="Modifier"/>
              <Button class="p-button-danger" @click="removeWdVerif(word.item.id)" label="Supprimer"/>
            </div>
        </template>
      </OrderList>
      <div class="flex mt-2">
        <Button @click="sortWords = 'alpha'" :label="sortWords == 'alpha' ? 'Trier par ordre alphabétique (Actif)' : 'Trier par ordre alphabétique'"/>
        <Button @click="sortWords = 'numeric'" class="ml-2" :label="sortWords == 'numeric' ? 'Trier par dernier mots ajoutés (Actif)' : 'Trier par dernier mots ajoutés'"/>
      </div>
    </div>
  </div>
  <div>
    <div class="mt-8">
      <h2>Panel</h2>
      <p>Artiphonie</p>
    </div>

    <Dialog v-model:visible="wdVerif">
        <template #header>
        <h3 class="warning">Supprimer un mot</h3>
        </template>

        <p>Vous êtes sur le point de supprimer définitivement le mot <strong>{{ $store.state.mots[wdVerifId].orthographe }}</strong> du dictionnaire</p>
        <p>Pour valider la suppression, veuillez cliquer sur "Supprimer"</p>

        <template #footer>
        <Button
        :loading="loadRemoveWord"
            label="Supprimer"
            class="p-button-danger"
            @click="removeWd()"
        />
        </template>
    </Dialog>

    <Dialog v-model:visible="modifyWord">
        <template #header>
        <h3>Modifier un mot</h3>

        <Button
            label="Sauvegarder les modifications"
            :loading="modifyWordLoad"
            :disabled="phoneticOldWord.length == 0 || oldWord.length == 0"
            class="p-button-primary"
            @click="modifyWordMethod()"
        />
        </template>

        <h5 :class="validationClass">Tous les champs sont obligatoires</h5>
        <div class="flex headerBottom">
          <div class="flex-1">
            <h5 for="newWord" class="mb-0">Nouveau mot</h5>
            <InputText
                id="newWord"
                type="text"
                v-model="oldWord"
                placeholder="Ecriture alphabétique"
                :class="alphaClass"
              />
          </div>
          <div class="flex-1">
            <h5 for="newWord" class="mb-2">Mot Polysyllabique (à partir de 3 syllabes)</h5>
            <Checkbox id="binary" v-model="oldPoly" :binary="true" />
            <label class="ml-1 pointer" for="binary">Polysyllabique</label>
          </div>
        </div>

        <h5 for="minmax-syllabel" class="mb-0">Ecriture phonétique</h5>
    <InputText
          type="text"
          v-model="phoneticOldWord"
          placeholder="Ecriture phonétique"
          :class="phoneticClass"
        />
      <h5 class="m-0 pointer" @click="showPhonem = !showPhonem"><span v-if="!showPhonem">Afficher</span><span v-else>Masquer</span> clavier phonétique</h5>
      <div class="resultPhonem">
        <h3>Résultat: <strong><span v-for="(item, index) in phoneticOldWord" :key="index">{{ translate[item] }}</span></strong></h3>
      </div>

      <div v-if="showPhonem" class="showPhonem">
        <hr>
        <div>
          <h3 class="mb-1">Voyelles orales</h3>
          <div class="gridPhonem">
            <div class="phonemVo" v-for="(item, index) in phonemTable.voyelle" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
          </div>
        </div>
        <div class="gridVoy mt-2">
          <div>
            <h3 class="mb-1">Voyelles Nasales</h3>
            <div class="gridPhonemThree">
              <div class="phonemVn" v-for="(item, index) in phonemTable.voyelleNas" :key="index" @click="phoneticOldWord += item.id">
                <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
                <div>{{ item.exemple }}</div>
              </div>
            </div>
          </div>
          <div>
            <h3 class="mb-1">Semi-Consonnes</h3>
            <div class="gridPhonemThree">
              <div class="phonemCsv" v-for="(item, index) in phonemTable.semivoyelle" :key="index" @click="phoneticOldWord += item.id">
                <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
                <div>{{ item.exemple }}</div>
              </div>
            </div>
          </div>
        </div>
        <div class="mt-2">
          <h3 class="mb-1">Consonnes</h3>
          <div class="gridPhonem">
            <div class="phonemCo" v-for="(item, index) in phonemTable.consCo" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCc" v-for="(item, index) in phonemTable.consCc" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCl" v-for="(item, index) in phonemTable.consCl" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCn" v-for="(item, index) in phonemTable.consCn" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
            <div class="phonemCs" v-for="(item, index) in phonemTable.consCs" :key="index" @click="phoneticOldWord += item.id">
              <h4 class="m-0">{{ item.phonem }} <span class="text-light">({{ item.id }})</span></h4>
              <div>{{ item.exemple }}</div>
            </div>
          </div>
        </div>
      </div>

        

        <!--<h5 for="minmax-syllabel">Nombre de syllabes</h5>
        <div class="flex flex-direction-row">
        <InputNumber
            id="minmax-syllabel"
            v-model="syllabelOldCount"
            mode="decimal"
            showButtons
            :min="0"
            :max="20"
            :class="syllabelClass"
        />
        </div>-->

        <template #footer>
        <Button
            label="Sauvegarder les modifications"
            :loading="modifyWordLoad"
            :disabled="phoneticOldWord.length == 0 || oldWord.length == 0"
            class="p-button-primary"
            @click="modifyWordMethod()"
        />
        </template>
    </Dialog>

    <div class="mt-8">
      <h2>Documentations/Explications</h2>
      <h3>Documentation du panel d'administration</h3>
      <a href="/DocOrtho.pdf" target="_blank" style="text-decoration: underline; color: blue">Accès à la documentation</a>

      <h3 class="mt-4">Télécharger l'application</h3>
      <a href="/Artiphonie.apk" target="_blank" style="text-decoration: underline; color: blue">Télécharger l'application (apk)</a>
    
      <h4 class="mt-8 mb-4">Version {{ $store.state.version }}</h4>
    </div>
  </div>
</template>

<script>
import Button from "primevue/button";
import InputText from "primevue/inputtext";
import InputNumber from "primevue/inputnumber";
import OrderList from "primevue/orderlist";
import Avatar from "primevue/avatar";
import Dialog from "primevue/dialog"
import Checkbox from "primevue/checkbox"
import CreatePatientAccount from "@/components/CreatePatientAccount.vue";
import AddWordToDict from "@/components/AddWordToDict.vue";

import axios from 'axios'

export default {
  name: "Welcome",
  components: {
    Button,
    InputText,
    OrderList,
    InputNumber,
    Avatar,
    Checkbox,
    Dialog,
    CreatePatientAccount,
    AddWordToDict,
  },
  data() {
    return {
      loadRemoveWord: false,
      sortWords: 'alpha',

      modifyWordLoad: false,
      search: "",
      searchWord: "",
      modifyWord: false,
      modifyWordId: 0,
      phoneticOldWord: "",
      oldStructSyllType: "",
      oldStructSyll: "",
      oldWord: "",
      oldPoly: false,
      syllabelOldCount: 0,
      validationClass: "validate-input",
      alphaClass: "validate-alpha",
      phoneticClass: "validate-phonetic",
      syllabelClass: "validate-syllabel",

      wdVerifId: 0,
      wdVerif: false,

      showPhonem: true,
      phonemTable: {
        voyelle: [
          {id: "i", phonem: "i", exemple: "si"},
          {id: "e", phonem: "e", exemple: "pré"},
          {id: "E", phonem: "ɛ", exemple: "père"},
          {id: "a", phonem: "a", exemple: "mal"},
          {id: "y", phonem: "y", exemple: "tu"},
          {id: "2", phonem: "ø", exemple: "peu"},
          {id: "°", phonem: "ə", exemple: "je"},
          {id: "9", phonem: "œ", exemple: "soeur"},
          {id: "u", phonem: "u", exemple: "cou"},
          {id: "o", phonem: "o", exemple: "zéro"},
          {id: "O", phonem: "ɔ", exemple: "sort"},
        ],
        voyelleNas: [
          {id: "5", phonem: "ɛ̃", exemple: "pain"},
          {id:"@", phonem: "ɑ̃", exemple: "blanc"},
          {id: "§", phonem: "ɔ̃", exemple: "pont"},
        ],
        semivoyelle: [
          {id: "8", phonem: "ɥ", exemple: "huit"},
          {id: "w", phonem: "w", exemple: "oiseau"},
          {id: "j", phonem: "j", exemple: "fille"}
        ],
        consCo: [
          {id: "p", phonem: "p", exemple: "pile"},
          {id: "b", phonem: "b", exemple: "bateau"},
          {id: "t", phonem: "t", exemple: "tout"},
          {id: "d", phonem: "d", exemple: "deux"},
          {id: "k", phonem: "k", exemple: "calme"},
          {id: "g", phonem: "g", exemple: "gâteau"},
        ],
        consCc: [
          {id: "f", phonem: "f", exemple: "fou"},
          {id: "v", phonem: "v", exemple: "va"},
          {id: "s", phonem: "s", exemple: "site"},
          {id: "z", phonem: "z", exemple: "zut"},
          {id: "S", phonem: "ʃ", exemple: "chocolat"},
          {id: "Z", phonem: "ʒ", exemple: "genou"},
        ],
        consCl: [
          {id: "R", phonem: "ʁ", exemple: "rue"},
          {id: "l", phonem: "l", exemple: "lit"}
        ],
        consCn: [
          {id: "m", phonem: "m", exemple: "mode"},
          {id: "n", phonem: "n", exemple: "nez"},
          {id: "N", phonem: "ɲ", exemple: "agneau"},
        ],
        consCs: [
          {id: "K", phonem: "ŋ", exemple: "parking"}
        ]
      },

      struct_syll_table: {
        "a": "V",
        "i": "V",
        "y": "V",
        "u": "V",
        "o": "V",
        "O": "V",
        "e": "V",
        "E": "V",
        "°": "V",
        "2": "V",
        "9": "V",

        "5": "V",
        "@": "V",
        "§": "V",

        "j": "C",
        "8": "C",
        "w": "C",

        "p": "C",
        "b": "C",
        "t": "C",
        "d": "C",
        "k": "C",
        "g": "C",

        "f": "C",
        "v": "C",
        "s": "C",
        "z": "C",
        "S": "C",
        "Z": "C",

        "m": "C",
        "n": "C",
        "N": "C",

        "l": "C",
        "R": "C",

        "K": "C",
      },

      struct_syll_type_table: {
        "a": "Vo",
        "i": "Vo",
        "y": "Vo",
        "u": "Vo",
        "o": "Vo",
        "O": "Vo",
        "e": "Vo",
        "E": "Vo",
        "°": "Vo",
        "2": "Vo",
        "9": "Vo",

        "5": "Vn",
        "@": "Vn",
        "§": "Vn",

        "j": "Csv",
        "8": "Csv",
        "w": "Csv",

        "p": "Co",
        "b": "Co",
        "t": "Co",
        "d": "Co",
        "k": "Co",
        "g": "Co",

        "f": "Cc",
        "v": "Cc",
        "s": "Cc",
        "z": "Cc",
        "S": "Cc",
        "Z": "Cc",

        "m": "Cn",
        "n": "Cn",
        "N": "Cn",

        "l": "Cl",
        "R": "Cl",

        "K": "Cs",
      },

      translate: {
        "a": "a",
        "i": "i",
        "y": "y",
        "u": "u",
        "o": "o",
        "O": "ɔ",
        "e": "e",
        "E": "ɛ",
        "°": "ə",
        "2": "ø",
        "9": "œ",
        "1": "œ̃",
        "3": "",

        "5": "ɛ̃",
        "@": "ɑ̃",
        "§": "ɔ̃",

        "j": "j",
        "8": "ɥ",
        "w": "w",

        "p": "p",
        "b": "b",
        "t": "t",
        "d": "d",
        "k": "k",
        "g": "g",

        "f": "f",
        "v": "v",
        "s": "s",
        "z": "z",
        "S": "ʃ",
        "Z": "ʒ",

        "m": "m",
        "n": "n",
        "N": "ɲ",

        "l": "l",
        "R": "ʁ",

        "K": "ŋ",

        "x": "",
        "G": ""
    },
    };
  },
  created() {
    if (!this.$store.state.user.isLoggedIn) {
      this.$router.push('/')
    } else {
        this.initPage();
    }
  },
  methods: {
    removeWdVerif(id) {
      for (let i = 0; i < this.$store.state.mots.length; i++) {
        if (this.$store.state.mots[i].id == id) {
          this.wdVerifId = i
          this.wdVerif = true
          break;
        }
      }
    },
      async removeWd() {
        this.loadRemoveWord = true
        await axios
        .delete("/mots/remove?mot_id=" + this.$store.state.mots[this.wdVerifId].id)
            .then((res) => {
              this.wdVerif = false
              this.$store.commit("removeMot", {id: this.$store.state.mots[this.wdVerifId].id})
              axios.post("/mots/check", {bdd_version: this.$store.state.motsVersion}).then(res => {
                if (!res.data.valid) {
                  this.$store.commit('importMots', {mots: res.data.complete.mots, bdd_version: res.data.complete.bdd_version})
                }
                this.loadRemoveWord = false
              }).catch(err => {
                this.loadRemoveWord = false
                console.log(err)
              })
            })
            .catch((error) => {
              this.loadRemoveWord = false
                console.error(error);
        });
      },
      async modifyWordMethod() {
        this.modifyWordLoad = true
        let newStruc = '', newStrucType = '', newSyllabelCount = 0
        for (let i = 0; i < this.phoneticOldWord.length; i++) {
          newStruc += this.struct_syll_table[this.phoneticOldWord[i]];
          newStrucType += this.struct_syll_type_table[this.phoneticOldWord[i]];
          if (this.struct_syll_table[this.phoneticOldWord[i]] == "V") {
            newSyllabelCount += 1
          }
        }
          await axios.post("/mots/update", {
            orthographe: this.oldWord,
            poly_syll: this.oldPoly,
            nb_syll: newSyllabelCount,
            struct_syll: newStruc,
            struct_syll_type: newStrucType,
            phonem: this.phoneticOldWord,
            id_ortho: this.$store.state.mots[this.modifyWordId].id_ortho,
            id: this.$store.state.mots[this.modifyWordId].id
        }).then(res => {
          this.$store.state.motsVersion += 1
          axios.post("/mots/check", {bdd_version: this.$store.state.motsVersion}).then(res => {
            console.log(res.data)
            if (!res.data.valid) {
              this.$store.commit('importMots', {mots: res.data.complete.mots, bdd_version: res.data.complete.bdd_version})
            } else {
              for (let i = 0; i < this.$store.state.mots.length; i++) {
                if (this.$store.state.mots[i].id == this.$store.state.mots[this.modifyWordId].id) {
                    this.$store.state.mots[i] = {
                        orthographe: this.oldWord,
                        poly_syll: this.oldPoly,
                        nb_syll: newSyllabelCount,
                        struct_syll: newStruc,
                        struct_syll_type: newStrucType,
                        phonem: this.phoneticOldWord,
                        id_ortho: this.$store.state.mots[this.modifyWordId].id_ortho,
                        id: this.$store.state.mots[this.modifyWordId].id
                    }
                    break;
                }
              }
            }
          }).catch(err => {
            console.log(err)
            this.modifyWordLoad = false
          })
            this.modifyWord = false
            this.modifyWordLoad = false
        }).catch (err => {
            console.log(err)
            this.modifyWordLoad = false
        })
      },
      modifyWd(id) {
        for (let i = 0; i < this.$store.state.mots.length; i++) {
          if (this.$store.state.mots[i].id == id) {
            this.oldWord = this.$store.state.mots[i].orthographe
            this.oldPoly = this.$store.state.mots[i].poly_syll
            this.oldStructSyllType = this.$store.state.mots[i].struct_syll_type
            this.oldStructSyll = this.$store.state.mots[i].struct_syll
            this.phoneticOldWord = this.$store.state.mots[i].phonem
            this.syllabelOldCount = this.$store.state.mots[i].nb_syll
            this.modifyWordId = i
            this.modifyWord = true
            break;
          }
        }
      },
    async initPage() {
      await axios
        .get("/enfants?id_ortho=" + this.$store.state.user.id)
        .then((res) => {
            this.$store.commit('importPatient', {patient: res.data})
          //this.patients = res.data
        })
        .catch((error) => {
          console.error(error);
        });
      await axios.post("/mots/check", {bdd_version: this.$store.state.motsVersion}).then(res => {
        if (!res.data.valid) {
          this.$store.commit('importMots', {mots: res.data.complete.mots, bdd_version: res.data.complete.bdd_version})
        }
      }).catch(err => {
        console.log(err)
      })
    // await axios
    //     .get("/mots")
    //     .then((res) => {
    //         this.$store.commit('importMots', {mots: res.data.mots, bdd_version: res.data.bdd_version})
    //       //this.patients = res.data
    //     })
    //     .catch((error) => {
    //       console.error(error);
    //     });
    },
  },
  computed: {
    filteredPatients() {
      let filteredPatients = Object.values(this.$store.state.patient);
      if (!this.search == "" && this.search) {
        filteredPatients = filteredPatients.filter((item) => {
          return (
            item.nom.toUpperCase().includes(this.search.toUpperCase()) ||
            item.prenom.toUpperCase().includes(this.search.toUpperCase()) ||
            item.classe.includes(this.search)
          );
        });
      }
      return filteredPatients;
    },
    filteredWords() {
      let filteredWords = Object.values(this.$store.state.mots);
      if (!this.searchWord == "" && this.searchWord) {
        filteredWords = filteredWords.filter((item) => {
          return (
            item.orthographe.toUpperCase().includes(this.searchWord.toUpperCase()) ||
            item.phonem.toUpperCase().includes(this.searchWord.toUpperCase()) ||
            String(item.nb_syll).includes(this.searchWord)
          );
        });
      }
      if (this.sortWords == 'alpha') {
        filteredWords.sort((a, b) => a.orthographe.localeCompare(b.orthographe))
      } else {
        filteredWords.sort((a, b) => parseInt(b.id) - parseInt(a.id))
      }
      return filteredWords;
    },
  },
};
</script>

<style lang="scss">
.text-light {
  font-weight: 300;
  font-size: 14px;
}

.hello-button {
  padding: 1rem;
}

.hello-searchbar {
  margin: 1rem;
}

.pi-search {
  padding-right: 5px;
}

.p-inputtext {
  width: 96%;
}

.p-orderlist-list {
  max-height: 29.5rem;
}

.validate-input {
  display: none;
}

.non-validate-input {
  color: red;
}

.non-validate-alpha {
  border-color: red;
}
.non-validate-phonetic {
  border-color: red;
}
.non-validate-syllabel > input {
  border-color: red;
}
</style>

<style lang="scss" scoped>
.patient-item {
  display: flex;
  align-items: center;
  padding: 0.5rem;
  width: 100%;
  text-align: left !important;

  .patient-list-detail {
    flex: 1 1 0;
  }

  .patient-niveau-icon {
    margin-right: 0.5rem;
    font-size: 0.875rem;
  }

  .patient-niveau {
    line-height: 1;
    font-size: 0.875rem;
  }
  .patient-description {
    line-height: 1;
    font-size: 0.775rem;
    margin-top: 0.2rem;
  }
}

@media screen and (max-width: 576px) {
  .patient-item {
    flex-wrap: wrap;
    text-align: center !important;

    .image-container {
      width: 100%;
      text-align: center;
    }
  }
}

a {
  text-decoration: none;
  color: inherit;
}
.p-inputtext {
  margin-right: 0.5rem !important;
}
</style>